from django.conf import settings
from django.template import Library, Node, TextNode

register = Library()

import texere


texere.init_texere(settings.LANGUAGE_DIR, settings.LANGUAGE_CODE)


@register.tag(name="texere")
def do_texere(parser, token):
    nodelist = parser.parse(('endtexere',))
    parser.delete_first_token()
    return TexereNode(nodelist)


class TexereNode(Node):

    def __init__(self, nodelist):
        self.nodelist = nodelist

    def render(self, context):
        values = context.dicts[-1]
        for node in self.nodelist:
            if isinstance(node, TextNode):
                node.s = texere.get_text(node.s).format(**values)
        output = self.nodelist.render(context)
        return output
